<template>
    <v-container>
        <Timeslots @submit="submit" />
    </v-container>
</template>

<script>
import {mapActions, mapState} from 'pinia';
import {useTimeslotsStore} from '@/store/timeslots';
import {serializeTimeslotFilters, deserializeTimeslotFilters} from '@/services/api';

export default {
    computed: mapState(useTimeslotsStore, ['filters']),
    methods: {
        ...mapActions(useTimeslotsStore, ['setFiltersObject', 'load']),
        async submit() {
            const filters = serializeTimeslotFilters(this.filters);
            await this.$router.push({ query: filters, params: filters });
        }
    },
    watch: {
        '$route.query': async function(value) {
            await this.setFiltersObject(deserializeTimeslotFilters(value));
            await this.load();
        }
    },
    async created() {
        await this.setFiltersObject(deserializeTimeslotFilters(this.$route.query));
        await this.load();
    }
}
</script>
